class PurpleSprig{

    String[][] rules = {{"F", "F"},
        {"X", "F[+++d][++d][+d]X", "d[---d][--d][-d]X"},
        {"+", "+"},
        {"-", "-"},
        {"*", "*"},
        {"/", "/"},
        {"[", "["},
        {"]", "]"},
        {"S", "S"},
    };

    String computedWord;
    int iterations;
    float size, angle, scaleFactor;
    float inc = 1;

    PurpleSprig(float size, float angle, float scaleFactor, String axiom) {
        this.size = size;
        this.angle = angle;
        this.scaleFactor = scaleFactor;
        computedWord = axiom;
        iterations = 0;
    }

    void iteration() {
        char s;
        String newWord = "";
        for (int i = 0; i < computedWord.length(); i++) {
            s = computedWord.charAt(i);
            for (int j = 0; j < rules.length; j++) {
                if (s == rules[j][0].charAt(0)) {
                    if (iterations > 4) {
                        break;
                    } else if (s == 'X') {
                        int num = (int) (random(2)) + 1;
                        println(iterations + " " + num);
                        newWord = newWord + rules[j][num];
                    } else {
                        newWord = newWord + rules[j][1];
                    }  
                    break;
                }
            }
        }
        iterations++;
        computedWord = newWord;
        //println(iterations + ": " + computedWord);
    }

    void drawLSystem(Turtle t) {
        char s;
        for (int i = 0; i < computedWord.length(); i++) {
            s = computedWord.charAt(i);
            if (s == 'F') {
                strokeWeight(2);
                t.forward(size / 2);
                strokeWeight(1);
            } else if (s == '+') {
                t.right(angle);
            } else if (s == 'd') { 
                t.forward(size / (random(4) + 4));
                strokeWeight(1);
                fill(#A29AEA);
                ellipse(t.getX(), t.getY(), 5, 5); 
            } else if (s == '+') {
                t.right(angle);
            } else if (s == '-') {
                t.left(angle);
            } else if (s == '[') {
                t.push();
            } else if (s == ']') {
                t.pop();
            } else if (s == '>') {
                t.left(15);
            } else if (s == '<') {
                t.right(15);
            } else if (s == 'S' && iterations == 1) {
                println("I get here");
                stem();
            } else if (s == 'f') {
                t.forward(size / 2);
            } else if (s == '*') {
                t.right(100);
            } else if (s == '/') {
                t.left(100);
            } 
        }
    }

    void my_arc(float l, float r) {
        //'''L = θ × (π/180) × r'''
        strokeWeight(1);
        beginShape();
        float theta = (l * 180.0) / (r * PI);
        float theta_inc = theta / l;
        for (int i = 0; i < l; i++) {
            vertex(t.getX(), t.getY());
            t.forward(1);
            t.left(theta_inc);
        }
        endShape(CLOSE);
        fill(#078167);
        strokeWeight(1);
    }

    void flower() {
        float angle = 0;
        float petalLength = random(10) + 5;
        //float angleInc = random(4);
        float startX = t.getX();
        float startY = t.getY();
        for (int i = 0; i < 360; i++) {
            stroke(#D8024D);
            t.forward(15);
            t.right(180);
            t.forward(15);
            t.right(angle);
            angle = 3 + angle;
        }
        fill(#FAD1E0);
        ellipse(t.getX(), t.getY(), 5, 5);
    }



    void stem() {
        strokeWeight(2);
        for (int i = 0; i < 8; i++) {
            println("stem" + i);
            t.forward(-20);
            if ((int) random(3) % 2 == 0) {
                t.right(5);
            } else {
                t.left(5);
            }
        }
    }
}
