/*****************************************
 * Large Assignment 1: L-Systems
 * Name:    Erin McClure
 * E-mail:  emccluree@unm.edu
 * Course:      CS491, Computational Fabrication
 * Submitted:    09/14/2022
 *
 * This draws an L system repersenting Papyrus 
 * based on the example in class
***********************************************/
class PapyrusCalss  {                
    String[][] rules = {{"F", "F"},
            {"X", "FF[-XYZ][+XYZ]F[-XYZ]", "F[++XYZ][-XYZ]FF[--XYZ]", "FF[+XYZ][-XYZ]F[+XYZ]", "F[--XYZ][+XYZ]FF[++XYZ]"},
            {"Y", "[+++++FW][++++FW][+++FW][++FW][+FW]", "[+++F][++F][+FW][FW]", "[+++++FW][+++FW][++FW][+FW]", "[+++++FW][++FW]"},
            {"Z", "[-----FW][----FW][---FW][--FW]", "[---FW][--FW][-FW][FW]", "[-----FW][---FW][--FW][-FW]", "[-----FW][--FW]"},
            {"+", "+"},
            {"-", "-"},
            {"[", "["},
            {"]", "]"},
            {"<", "<"},
            {">", ">"},
            {"W", "W"},
    }; 
    String computedWord;
    int iterations = 0;
    float size, angle, scaleFactor;
    PapyrusCalss (float size, float angle, float scaleFactor, String axiom) { 
        this.size = size;
        this.angle = angle;
        this.scaleFactor = scaleFactor;
        computedWord = axiom; 
    }
    void iteration() { 
        
        char s;
        String newWord = "";
        size = size*scaleFactor;
        //loop through computedWord
        for (int i = 0; i<computedWord.length(); i++) {
            //for every symbol
            s = computedWord.charAt(i);
            //loop through rules to find a match 
            for (int j=0; j<rules.length;j++) {
                if (s == rules[j][0].charAt(0)) {
                  if (s == 'Y' || s == 'Z') {
                     int num = (int)(random(3)+1);
                     newWord = newWord + rules[j][num];
                   }else if(s == 'X'){
                    int num = (int)(random(3)+1);
                    //println();
                    newWord = newWord + rules[j][num]; 

                  }else{
                    newWord = newWord + rules[j][1];
                  }
                 //newWord = newWord + rules[j][1];
                  break;
                }//replacement
             
            }
        }
        iterations++;
        computedWord = newWord;
       
        println(iterations +": " +computedWord);
    }
    
    void drawLSystem(Turtle t) {
        //loop through computedWord and draw each symbol 
        char s;
        for (int i=0;i<computedWord.length();i++) {
            s = computedWord.charAt(i); 
            if (s=='F'){
              t.forward(size);
            } else if (s=='+'){
              t.right(angle); 
            }else if (s=='-'){
              t.left(angle);
            }else if(s=='['){
              t.push();
            }else if(s == ']'){
              t.pop();
            }else if (s == '>'){
              t.left(5);
            }else if( s =='<'){
              t.right(15);
           }else if (s == 'W'){
             ellipse(t.getX(), t.getY(), 2,2);
           };
           }
        } 
        
    }

   
